<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/extern/bower_components/iron-icon/iron-icon.html">
<link rel="import" href="/extern/bower_components/iron-icons/iron-icons.html">
<link rel="import" href="/extern/bower_components/iron-pages/iron-pages.html">
<link rel="import" href="/extern/bower_components/paper-tabs/paper-tabs.html">
<link rel="import" href="/extern/bower_components/paper-listbox/paper-listbox.html">
<link rel="import" href="/extern/bower_components/paper-item/paper-item.html">
<link rel="import" href="/extern/bower_components/paper-fab/paper-fab.html">
<link rel="import" href="/extern/bower_components/neon-animation/neon-animated-pages.html">
<link rel="import" href="/extern/bower_components/neon-animation/neon-animatable.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-right-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-left-animation.html">
<link rel="import" href="/extern/bower_components/neon-animation/animations/slide-from-right-animation.html">
<link rel="import" href="/ts/common-elements/relative-time/relative-time.html">
<link rel="import" href="/extern/bower_components/vaadin-grid/vaadin-grid.html">
<link rel="import" href="/ts/common-elements/charts/stacked-area-chart/stacked-area-chart.html">
<link rel="import" href="/ts/common-elements/charts/pie-chart/pie-chart.html">
<link rel="import" href="/ts/common-elements/file-saver-js/file-saver-js.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">

<dom-module id="ts-about">
  <template>
    <style include="reset-css"></style>
    <style include="iron-flex-layout-attributes"></style>

    <link rel="stylesheet" type="text/css" href="css/ts-about-min.css?__inline=true">

    <ts-ajax id="getCoreDump"
             callback="getCoreDump"
             data="{{coreDump}}"
             parameters='["filename"]'></ts-ajax>
    <ts-ajax id="getCoreDumps"
             callback="getCoreDumps"
             data="{{coreDumps}}"
             auto></ts-ajax>
    <ts-ajax id="getLogs"
             data="{{rawLogs}}"
             callback="getLogs"
             auto></ts-ajax>
    <auto-update id="getCPU"
                 callback="getCPU"
                 handle-as="text"
                 on-data-changed="addCPUData"
                 interval="3000"
                 headless></auto-update>
    <auto-update id="getMemory"
                 callback="getMemory"
                 handle-as="text"
                 on-data-changed="addMemoryData"
                 interval="60000"
                 headless></auto-update>




    <neon-animated-pages selected="{{selectedMode}}"
                         attr-for-selected="mode">

      <!-- <ts-about-info mode="info"></ts-about-info>
      <ts-about-coredumps mode="coredumps"></ts-about-coredumps> -->

      <neon-animatable mode="info"
                       entry-animation="slide-from-left-animation"
                       exit-animation="slide-left-animation">
        <template is="dom-if" if="{{thereAreCoreDumps(coreDumps)}}" restamp="true">
          <div horizontal layout align-center style="padding-bottom:5px;">
            <iron-icon icon="error"></iron-icon>
            <p>Your cell contains some core dumps!</p>
            <paper-fab icon="arrow-forward" on-click="gotoCoredumps"></paper-fab>
          </div>
        </template>
        <div horizontal layout flex-stretch-with-space>
          <div center>
            <p tiny>Version</p>
            <p>[[data.version]]</p>
          </div>
          <div center>
            <p tiny>Compiled</p>
            <relative-time date="[[data.compiled]]"></relative-time>
          </div>
          <div center>
            <p tiny>Started</p>
            <relative-time date="[[data.started]]"></relative-time>
          </div>
        </div>

        <div horizontal layout style="height:200px;">
          <div vertical layout flex>
            <p title>CPU usage</p>
            <stacked-area-chart id="cpuchart" flex data="{{cpudata}}" config="{{cpuconfig}}" configure-chart="{{cpuconfigjs}}"></stacked-area-chart>
          </div>
          <div vertical layout style="width:200px;">
            <p title>Memory usage</p>
            <pie-chart id="memchart" flex data="{{memdata}}" config="{{memconfig}}" configure-chart="{{memconfigjs}}"></pie-chart>
          </div>
        </div>

        <div>

          <template is="dom-if" if="{{!onlyOneLogfile(rawLogs)}}" restamp="true">
            <paper-tabs selected="{{selectedLog}}" scrollable>
              <template is="dom-repeat" items="[[filteredLogs]]" as="log">
                <paper-tab>[[log.file]]</paper-tab>
              </template>
            </paper-tabs>
          </template>
          <iron-pages selected="{{selectedLog}}">
            <template is="dom-repeat" items="[[filteredLogs]]" as="log" on-rendered-item-count-changed="insertFilters">
              <div>
                <vaadin-grid items="{{log.content}}"
                             columns="{{getLogsColumns()}}"></vaadin-grid>
              </div>
            </template>
          </iron-pages>

        </div>

      </neon-animatable>

      <neon-animatable mode="coredumps"
                       entry-animation="slide-from-right-animation"
                       exit-animation="slide-right-animation">
        <div horizontal layout flex-stretch align-center style="padding-bottom:5px;">
          <paper-fab icon="arrow-back" on-click="gotoInfo"></paper-fab>
          <paper-button id="download" disabled on-click="downloadCoreDump"><iron-icon icon="file-download"></iron-icon>download</paper-button>

        </div>
        <div horizontal layout>
          <paper-listbox selected="{{selectedCoreDump}}">
            <template is="dom-repeat" items="[[coreDumps]]" as="filename">
              <paper-item>[[filename]]</paper-item>
            </template>
          </paper-listbox>
          <div flex horizontal layout align-center flex-center>
            <p style="white-space: pre-wrap;margin:5px;">[[coreDump.output]]</p>
          </div>
        </div>
      </neon-animatable>

    </neon-animated-pages>

  </template>
  <script src="javascript/ts-about-min.js?__inline=true"></script>
</dom-module>
